/*
 *	main.c
 *
 *	XM Player II
 *
 *	* Thu Nov 11 20:20:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int retval;
	int len;
	FILEINFO fi;
	FILEACC fa;
	XMGENERALHEADER* mh;
	XMINFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/

	/* XMt@CT܂B */
	memset(xm_info, 0, sizeof xm_info);
	xm_count = 0;
	mi = &xm_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(xm_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".xm"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 3) continue;
		if(strcasecmp(&fi.filename[len - 3], ".xm") != 0) continue;
		/* t@Cƃx[Xi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len    );
		memcpy(mi->bname, fi.filename, len - 3);
		/* ^Cgi[܂B */
		retval = pceFileOpen(&fa, mi->fname, FOMD_RD);
		if(retval != 0) DIE();
		retval = pceFileReadSct(&fa, NULL, 0, BLOCKSIZE);
		if(retval == 0) DIE();
		mh = (XMGENERALHEADER*)fa.aptr; /* XMGENERALHEADER͍ŏ1ZN^Ɏ܂Ă̂ŁA񂹂ɂ̂܂ܓǂ߂܂ */
		strncpy(mi->title, mh->module_name, MAXXMTITLE);
		pceFileClose(&fa);
		xm_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(xm_count == 0) {
		err_disp("XMt@C܂");
		exit(0);
	}

	/* Ԃ́A~łB */
	curplay = -1;

/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɒ~܂B */
	xm_stop();

#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		/* ɃX^oCɗȂ悤ɁB */
		pceAppActiveResponse(AAR_ACTIVE);

		/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
		if(now % SEC(1) == 0) {
			draw = 1;
		}

		/* ʍXVB */
		if(draw) {
			pceLCDTrans();
			draw = 0;
		}

		//pceLCDTrans();	/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	int retval;
	int i;
	int y;
	int c;
	const void* romp;
	XMINFO* mi;

	goto L10; /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0           ) cursel--;
		if(joy & TRG_DN && cursel < xm_count - 1) cursel++;
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			xm_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &xm_info[cursel];
			romp = mmap(mi->fname, NULL, 1/*DEFRAG*/);
			retval = xm_play(romp);
			if(retval == 0) {
				curplay = cursel;
			} else {
				err_disp("Đł܂ł");
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			xm_stop();
			curplay = -1;
		}

L10:
		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		mi = &xm_info[0];
		for(i = 0; i < xm_count; i++) {
			y = 8 + (i - curtop) * 6;
			if(i == cursel) {
				if(i == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			render_string(&render, 4 + 4 *  0, y, mi->bname, 0x82, c);
			render_string(&render, 4 + 4 *  8, y, ":",       0x82, c);
			render_string(&render, 4 + 4 * 10, y, mi->title, 0x82, c);
			mi++;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"========== XM Player II ==========",
			0x82, 0);

		/* ʓ]B */
		draw = 1;
	}
}
